<?
if(!file_exists("config.php")) die("ERROR: config.php and exec.php must be in the same dir.\n");
if(!file_exists("functions.php")) die("ERROR: functions.php and exec.php must be in the same dir.\n");

include("config.php");
include("functions.php");

if(!file_exists($log['file'])) {
  die("ERROR: The specified log file: \"" . $log['file'] . "\" doesn't exist.\n");
} else {
  echo "Parsing log file: \"" . $log['file'] . "\".\n";
}

if(filesize($log['file'])==0) {
  die("ERROR: The log file is empty, stopping now.\n");
}

if(!is_dir($log['save']) && !eregi("/dev/null",$log['save'])) {
  die("ERROR: The specified directory: \"" . $log['save'] . "\" doesn't exist.\n");
} else {
  if(!@copy($log['file'],$log['save'] . "/" . time() . ".bak")) {
    die("ERROR: Could not create back of log file: \"" . $log['file'] . "\".\n");
  }
}

$fp = fsockopen("udp://" . $server['ip'], $server['port'] + 123);

if(!$fp) {
  echo "Server is down, continuing.\n";
} else {
  fputs($fp,"s");
  $c = "";

  do {
    $c .= fread ($fp,1);
    $fpstatus = socket_get_status($fp);
  } while($fpstatus["unread_bytes"]);

  fclose ($fp);

  $query   = strchr($c,"?");
  $players = explode("?",$query);
  unset($players[0]);

  if(count($players)!=0) die("Cannot parse while players are connected.\n");
}

$start = utime();
$fp    = @fopen($log['file'],"r+");

mysql_connect($mysql['host'],$mysql['user'],$mysql['pass']) or die("ERROR: " . mysql_error());
mysql_select_db($mysql['db']) or die("ERROR: " . mysql_error());

$vehicles = array(1 => "Ambulance", 2 => "Sentinel XS", 3 => "Stinger", 4 => "Sabre Turbo", 5 => "Cheetah", 6 => "PCJ 600", 7 => "Sanchez", 8 => "Angel", 9 => "VCN Maverick", 10 => "PCJ 600", 11 => "Maverick", 12 => "Police Maverick", 13 => "Hunter", 14 => "Bloodring Banger", 15 => "Bloodring Banger", 16 => "Bloodring Banger", 17 => "Bloodring Banger", 18 => "PCJ 600", 19 => "PCJ 600", 20 => "PCJ 600", 21 => "PCJ 600", 22 => "PCJ 600", 23 => "FBI Rancher", 24 => "Packer", 25 => "Hotring Racer", 26 => "Hotring Racer", 27 => "Hotring Racer", 28 => "Hotring Racer", 29 => "Cheetah", 30 => "Comet", 31 => "Infernus", 32 => "Mesa Grande", 33 => "Stinger", 34 => "Securicar", 35 => "Mr. Whoopee", 36 => "Sanchez", 37 => "Cheetah", 38 => "Bobcat", 39 => "Packer", 40 => "Police", 41 => "Police", 42 => "Love Fist", 43 => "Sanchez", 44 => "Faggio", 45 => "Rancher", 46 => "Sentinel XS", 47 => "Mule", 48 => "Firetruck", 49 => "Benson", 50 => "Maverick", 51 => "Freeway", 52 => "Phoenix", 53 => "Enforcer", 54 => "Burrito", 55 => "Sentinel XS", 56 => "Washington", 57 => "Maverick", 58 => "PCJ 600", 59 => "Perennial", 60 => "Mesa Grande", 61 => "Rancher", 62 => "Stinger", 63 => "Bus", 64 => "Sandking", 65 => "Sanchez", 66 => "Idaho", 67 => "Mule", 68 => "Linerunner", 69 => "Barracks OL", 70 => "Patriot", 71 => "Benson", 72 => "Deluxo", 73 => "Washington", 74 => "PCJ 600", 75 => "Comet", 76 => "Caddy", 77 => "Sanchez", 78 => "Idaho", 79 => "Rancher", 80 => "Sabre Turbo");
$weapons  = array(1 => "Tec-9", 2 => "Shotgun", 3 => "Stubby Shotgun", 4 => "Colt .45", 5 => "Silenced Ingram", 6 => "Stubby Shotgun", 7 => "Python", 8 => "Silenced Ingram", 9 => "Molotov Cocktail", 10 => "Chainsaw", 11 => "Molotov Cocktail", 12 => "Ruger", 13 => "Python", 14 => "Silenced Ingram", 15 => "Shotgun", 16 => "M4", 17 => "Python", 18 => "M4", 19 => "MP5", 20 => "Grenade", 21 => "Molotov Cocktail", 22 => "Tec-9", 23 => "Colt .45", 24 => "SPAS12 Shotgun", 25 => "Python", 26 => "Molotov Cocktail", 27 => "Python", 28 => "Shotgun", 29 => "Tec-9", 30 => "Shotgun", 31 => "Colt .45", 32 => "Colt .45", 33 => "Tec-9", 34 => "Shotgun", 35 => "Flame Thrower", 36 => "Colt .45", 37 => "Molotov Cocktail", 38 => "Python");

if(!$fp) {
  die("ERROR: Failed opening log file: " . $log['file'] . " for reading/writing\n");
} else {
  $raw = fread($fp, filesize($log['file']));
  $raw = explode("\n", $raw);
}

foreach($raw as $temp) {
  if(substr($temp,0,4) == "Join") {
    list($null,$id,$name) = split("Join:|",$temp);
    $id           = trim($id);
    $name         = addslashes(trim($name));
    $players[$id] = array("name"=>$name);

    if(check_player($name)==0) {
      mysql_query("INSERT INTO " . $mysql['prefix'] . "_players(id,name,joins,time) VALUES(NULL,'{$name}','1','" . time() . "')");
    } else {
      mysql_query("UPDATE " . $mysql['prefix'] . "_players SET joins = joins+1, time = '" . time() . "' WHERE name = '{$name}'");
    }
  }

  if(substr($temp,0,4) == "Kill") {
    list($null,$id,$kid) = split(" ",$temp);
    $id  = trim($id);
    $kid = trim($kid);

    if($id == $kid) {
      mysql_query("UPDATE " . $mysql['prefix'] . "_players SET suicides = suicides+1 WHERE name = '{$players[$id]['name']}'");
    } else {
      mysql_query("UPDATE " . $mysql['prefix'] . "_players SET kills = kills+1 WHERE name = '{$players[$id]['name']}'");
      mysql_query("UPDATE " . $mysql['prefix'] . "_players SET deaths = deaths+1 WHERE name = '{$players[$kid]['name']}'");
    }

    mysql_query("INSERT INTO " . $mysql['prefix'] . "_action VALUES(NULL,'kill','{$players[$id]['name']}','{$players[$kid]['name']}','" . time() . "')");
  }

  if(substr($temp,0,3) == "Veh") {
    list($null,$id,$vid) = split(" ",$temp);
    $id  = trim($id);
    $vid = trim($vid);

    if($vid > 0 && $vid < 81) {
      mysql_query("INSERT INTO " . $mysql['prefix'] . "_action VALUES(NULL,'veh','{$players[$id]['name']}','{$vehicles[$vid]}','" . time() . "')");
    }
  }

  if(substr($temp,0,3) == "Wea") {
    list($null,$id,$wid) = split(" ",$temp);
    $id  = trim($id);
    $wid = trim($wid);

    if($wid > 0 && $wid < 39) {
      mysql_query("INSERT INTO " . $mysql['prefix'] . "_action VALUES(NULL,'wea','{$players[$id]['name']}','{$weapons[$wid]}','" . time() . "')");
    }
  }

  if(substr($temp,0,4) == "--->") {
    list($id,$say) = explode(": ",$temp);
    $id  = ereg_replace("^--->","",$id);
    $id  = addslashes(trim($id));
    $say = addslashes(trim($say));

    if(!empty($say)) mysql_query("INSERT INTO " . $mysql['prefix'] . "_chat VALUES(NULL,'{$id}','{$say}','" . time() . "')");
  }

  if(substr($temp,0,4) == "Quit") {
    list($null,$id) = split(" ",$temp);
    $id = trim($id);

    unset($players[$id]);
  }
}
ftruncate($fp,0);
fwrite($fp,"");
fclose($fp);

$end = utime();
$run = $end - $start;

echo "Stats generated in " . substr($run,0,5) . " seconds.\n";
?>
